/***************************************************************************
    copyright            : (C) 2005-2006 by Robby Stephenson
    email                : robby@periapsis.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This file has been modified to match the requirements of KBibTeX.     *
 *   In case of problems or bugs arising from this implementation, please  *
 *   contact the KBibTeX team first.                                       *
 *                             Thomas Fischer <fischer@unix-ag.uni-kl.de>  *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of version 2 of the GNU General Public License as  *
 *   published by the Free Software Foundation;                            *
 *                                                                         *
 ***************************************************************************/

#include "messagehandler.h"

#include <tdemessagebox.h>

namespace KBibTeX {

// all messages go to manager
void ManagerMessage::send(const TQString& message_, Type type_) {
//   Fetch::Manager::self()->updateStatus(message_);
  // plus errors get a message box
  if(type_ == Error) {
    KMessageBox::sorry(NULL, message_); // FIXME: some widget instead of NULL
  } else if(type_ == Warning) {
    KMessageBox::information(NULL, message_); // FIXME: some widget instead of NULL
  }
}

void ManagerMessage::infoList(const TQString& message_, const TQStringList& list_) {
  KMessageBox::informationList(NULL, message_, list_); // FIXME: some widget instead of NULL
}

}
